<?php
/**
 * Glo Test
 *
 */

require("connect_config.php");
require("until.php");


###########################################
# MAIN
###########################################

if ($argc != 6) {
    echo "usage: php glo.php person_name image_file output_image_file update_image_file output_image_file_2\n";
    exit;
}

$cubrid_conn = cubrid_connect(HOST_IP, HOST_PORT, DB_NAME, DB_USER, DB_PASSWORD);
if (!$cubrid_conn) {
    exit;
}

if (!prepare_table($cubrid_conn)) {
    exit;
}

$oid = cubrid_new_glo ($cubrid_conn, "glo", $argv[2]);
if (!$oid) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$sql_stmt = "insert into person(name, image) values(?, ?);";
$cubrid_req = cubrid_prepare($cubrid_conn, $sql_stmt, CUBRID_INCLUDE_OID);
if (!$cubrid_req) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$cubrid_retval = cubrid_bind($cubrid_req, 1, $argv[1]);
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$cubrid_retval = cubrid_bind($cubrid_req, 2, $oid, "object");
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$cubrid_retval = cubrid_execute($cubrid_req);
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
} 

cubrid_close_request($cubrid_req);
cubrid_commit($cubrid_conn);

$cubrid_retval = cubrid_load_from_glo ($cubrid_conn, $oid, $argv[3]);
if (!$cubrid_retval) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
} 

$cubrid_retval = cubrid_save_to_glo($cubrid_conn, $oid, $argv[4]);
if (!$cubrid_retval) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
} 

$cubrid_retval = cubrid_load_from_glo($cubrid_conn, $oid, $argv[5]);
if (!$cubrid_retval) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
} 

/*cubrid_send_glo($cubrid_conn, $oid);*/

cleanup_table($cubrid_conn);
cubrid_disconnect($cubrid_conn);

?>
