<?php
/**
 * Insert, update and delete Test
 *
 */

require("connect_config.php");
require("until.php");

echo "<pre>";

###########################################
# MAIN
###########################################

print_test_table();

$cubrid_conn = cubrid_connect(HOST_IP, HOST_PORT, DB_NAME, DB_USER, DB_PASSWORD);
if (!$cubrid_conn) {
    exit;
}

if (!prepare_table($cubrid_conn)) {
    exit;
}

$sql_stmt = "INSERT INTO foo(d) VALUES('php-test')";

$cubrid_req = cubrid_prepare($cubrid_conn, $sql_stmt);
if (!$cubrid_req) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

for ($i = 0; $i < 10; $i++) {
    $cubrid_retval = cubrid_execute($cubrid_req);
}
cubrid_commit($cubrid_conn);

$id_list = cubrid_insert_id("foo");
while($value = each($id_list)) {
    print_r($value);
}
printf("\n");

$req_handle = cubrid_execute($cubrid_conn, "DELETE FROM foo WHERE d = 'php-test'", CUBRID_ASYNC);
printf("affected_rows(insert): %d\n", cubrid_affected_rows($req_handle));

unbuffered_query_test($cubrid_conn);
real_escaped_string_test();

cleanup_table($cubrid_conn);

cubrid_close_request($cubrid_req);
cubrid_commit($cubrid_conn);
cubrid_disconnect($cubrid_conn);

echo "</pre>";

###########################################
# PRIVATE FUNCTION
###########################################

function unbuffered_query_test($cubrid_conn)
{
    $sql_stmt = "SELECT * FROM code";
    
    printf("\n------------unbuffered query: SELECT * FROM CODE --------------------\n");

    $result = cubrid_unbuffered_query($sql_stmt);
    print_result($result);

    cubrid_unbuffered_query($sql_stmt, $cubrid_conn);

    printf("\n");
}

function real_escaped_string_test()
{
    $sql_stmt = "SELECT \abc\, 'ds' FROM db_root";

    printf("sql: %s -> escaped_sql: %s\n", $sql_stmt, cubrid_real_escape_string($sql_stmt));

    printf("\n");
}

?>
