<?php
/**
 * Schema info Test
 *
 */

require("connect_config.php");
require("until.php");

echo "<pre>";

###########################################
# MAIN
###########################################

print_test_table();

$schema_list = array(
    array("schema_type" => CUBRID_SCH_CLASS, "schema_name" => "CUBRID_SCH_CLASS", "class" => "game", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_CLASS, "schema_name" => "CUBRID_SCH_CLASS", "class" => "db_user", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_CLASS, "schema_name" => "CUBRID_SCH_CLASS", "class" => "db_class", "attr" => NULL),

    array("schema_type" => CUBRID_SCH_VCLASS, "schema_name" => "CUBRID_SCH_VCLASS", "class" => "db_class", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_ATTRIBUTE, "schema_name" => "CUBRID_SCH_ATTRIBUTE", "class" => "game", "attr" => "event_code"),
    array("schema_type" => CUBRID_SCH_METHOD, "schema_name" => "CUBRID_SCH_METHOD", "class" => "glo", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_CLASS_METHOD, "schema_name" => "CUBRID_SCH_CLASS_METHOD", "class" => "glo", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_SUPERCLASS, "schema_name" => "CUBRID_SCH_SUPRECLASS", "class" => "bar", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_SUBCLASS, "schema_name" => "CUBRID_SCH_SUBCLASS", "class" => "foo", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_CONSTRAINT, "schema_name" => "CUBRID_SCH_CONSTRAINT", "class" => "game", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_TRIGGER, "schema_name" => "CUBRID_SCH_TRIGGER", "class" => "glo_delete_contents", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_CLASS_PRIVILEGE, "schema_name" => "CUBRID_SCH_CLASS_PRIVILEGE", "class" => "foo", "attr" => NULL),
    array("schema_type" => CUBRID_SCH_ATTR_PRIVILEGE, "schema_name" => "CUBRID_SCH_ATTR_PRIVILEGE", "class" => "game", "attr" => "event_code"),
    array("schema_type" => CUBRID_SCH_PRIMARY_KEY, "schema_name" => "CUBRID_SCH_PRIMARY_KEY", "class" => "game", "attr" => NULL)
    );

$schema_result_list = array( 
    array(CUBRID_SCH_CLASS, "NAME", "TYPE"), 
    array(CUBRID_SCH_VCLASS, "NAME", "TYPE"), 
    array(CUBRID_SCH_ATTRIBUTE, "ATTR_NAME", "DOMAIN", "SCALE", "PRECISION", "INDEXED", "NON_NULL", "SHARED", "UNIQUE", "DEFAULT", "ATTR_ORDER", "CLASS_NAME", "SOURCE_CLASS", "IS_KEY"), 
    array(CUBRID_SCH_METHOD, "NAME", "RET_DOMAIN", "ARG_DOMAIN"), 
    array(CUBRID_SCH_CLASS_METHOD, "NAME", "RET_DOMAIN", "ARG_DOMAIN"), 
    array(CUBRID_SCH_SUPERCLASS, "CLASS_NAME", "TYPE"), 
    array(CUBRID_SCH_SUBCLASS, "CLASS_NAME", "TYPE"), 
    array(CUBRID_SCH_CONSTRAINT, "TYPE", "NAME", "ATTR_NAME", "NUM_PAGES", "NUM_KEYS", "PRIMARY_KEY", "KEY_ORDER"), 
    array(CUBRID_SCH_TRIGGER, "NAME", "STATUS", "EVENT", "TARGET_CLASS", "TARGET_ATTR", "ACTION_TIME", "ACTION", "PRIORITY", "CONDITION_TIME", "CONDITION"), 
    array(CUBRID_SCH_CLASS_PRIVILEGE, "CLASS_NAME", "PRIVILEGE", "GRANTABLE"), 
    array(CUBRID_SCH_ATTR_PRIVILEGE, "ATTR_NAME", "PRIVILEGE", "GRANTABLE"), 
    array(CUBRID_SCH_PRIMARY_KEY, "CLASS_NAME", "ATTR_NAME", "KEY_SEQ", "KEY_NAME"), 
    );

$cubrid_conn = cubrid_connect_with_url(CONNECT_URL);
if (!$cubrid_conn) {
    exit;
}

if (!prepare_table($cubrid_conn)) {
    exit;
}

$schema_size = count($schema_list);
$result_size = count($schema_result_list);
for ($i = 0; $i < $schema_size; $i++) {
    if ($schema_list[$i]["attr"] == NULL) {
	$schema_info = cubrid_schema($cubrid_conn, 
	    $schema_list[$i]["schema_type"], $schema_list[$i]["class"]); 
    } else {
	$schema_info = cubrid_schema($cubrid_conn, 
	    $schema_list[$i]["schema_type"], $schema_list[$i]["class"], $schema_list[$i]["attr"]); 
    }

    if ($schema_info == -1) {
	cleanup_table($cubrid_conn);
	cubrid_disconnect($cubrid_conn);
	exit;	    
    }

    printf("\n---------- %s (%s, %s) ---------\n", 
	$schema_list[$i]["schema_name"], $schema_list[$i]["class"], $schema_list[$i]["attr"]);

    for ($j = 0; $j < $result_size; $j++) {
	if ($schema_result_list[$j][0] == $schema_list[$i]["schema_type"]) {
	    $size = count($schema_result_list[$j]);

	    while (list($key, $value) = each($schema_info)) {
		for ($k = 1; $k < $size; $k++) {
		    if ( $value[$schema_result_list[$j][$k]] != NULL) {
			printf("'%s' ", $value[$schema_result_list[$j][$k]]);
		    } else {
			printf("'<null>' "); 
		    }
		}
		printf("\n");
	    }
	}
    }
    printf("\n");
}

cleanup_table($cubrid_conn);

cubrid_commit($cubrid_conn);
cubrid_disconnect($cubrid_conn);

echo "</pre>";
?>
