<?php
/**
 * Set Test
 *
 */

require("connect_config.php");
require("until.php");

echo "<pre>";

###########################################
# MAIN
###########################################

print_test_table();

$cubrid_conn = cubrid_connect(HOST_IP, HOST_PORT, DB_NAME, DB_USER, DB_PASSWORD);
if (!$cubrid_conn) {
    exit;
}

if (!prepare_table($cubrid_conn)) {
    exit;
}

$sql_stmt = "SELECT a FROM foo";
$cubrid_req = cubrid_prepare($cubrid_conn, $sql_stmt, CUBRID_INCLUDE_OID);
if (!$cubrid_req) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$cubrid_retval = cubrid_execute($cubrid_req);
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$row = cubrid_fetch_row($cubrid_req);
$oid = cubrid_current_oid($cubrid_req);
if (!$oid) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

printf("line 1:\n");
printf("------------ add value(33) to foo(b) --------------------\n");

$cubrid_retval = cubrid_set_add($cubrid_conn, $oid, "b", "33");
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

cubrid_commit($cubrid_conn);
print_foo($cubrid_conn);

printf("------------ drop value(33) from foo(b) --------------------\n");

$cubrid_retval = cubrid_set_drop($cubrid_conn, $oid, "b", "33");
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

cubrid_commit($cubrid_conn);
print_foo($cubrid_conn);

printf("------------ insert value(999) to index 1 of foo(c) --------------------\n");

$cubrid_retval = cubrid_seq_insert($cubrid_conn, $oid, "c", 1, "999");
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

cubrid_commit($cubrid_conn);
print_foo($cubrid_conn);

printf("------------ add value(888) to foo(c) --------------------\n");

$cubrid_retval = cubrid_seq_put($cubrid_conn, $oid, "c", 1, "888");
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

cubrid_commit($cubrid_conn);
print_foo($cubrid_conn);

printf("------------ drop index 1 from foo(c) --------------------\n");

$cubrid_retval = cubrid_seq_drop($cubrid_conn, $oid, "c", 1);
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

cubrid_commit($cubrid_conn);
print_foo($cubrid_conn);

printf("\n------------ result: select * from foo --------------------\n");
print_foo($cubrid_conn);

cleanup_table($cubrid_conn);

cubrid_close_request($cubrid_req);
cubrid_disconnect($cubrid_conn);

echo "</pre>";
?>
