<?php
/**
 * Type Test
 *
 */

require("connect_config.php");
require("until.php");

echo "<pre>";

###########################################
# MAIN
###########################################

print_type_test_table();

$cubrid_conn = cubrid_connect(HOST_IP, HOST_PORT, DB_NAME, DB_USER, DB_PASSWORD);
if (!$cubrid_conn) {
    exit;
}

if (!prepare_table($cubrid_conn)) {
    exit;
}

$sql_stmt = "SELECT * FROM baz WHERE 
    column_integer = ? AND column_smallint = ? AND 
    column_numeric_9_2 = ? AND column_char_9 = ? AND 
    column_varchar_92 = ?";

$cubrid_req = cubrid_prepare($cubrid_conn, $sql_stmt);
if (!$cubrid_req) {
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

$param = array (333, 3333, 3.3, "333", "dba");
$type = array ("int", "short", "numeric", "char", "string");

$size = count($param);

for ($i = 0; $i < $size; $i++) {
    $cubrid_retval = cubrid_bind($cubrid_req, $i + 1, $param[$i], $type[$i]);
    if (!$cubrid_retval) {
	printf("bind fail: %s %s\n", $param[$i], $type[$i]);
	cleanup_table($cubrid_conn);
	cubrid_close_request($cubrid_req);
	cubrid_disconnect($cubrid_conn);
	exit;
    }
}

$cubrid_retval = cubrid_execute($cubrid_req);
if (!$cubrid_retval) {
    cubrid_close_request($cubrid_req);
    cleanup_table($cubrid_conn);
    cubrid_disconnect($cubrid_conn);
    exit;
}

get_result_info($cubrid_req);

printf("\n------------ result: select from baz where column_integer = 3 ... --------------------\n");

cubrid_move_cursor($cubrid_req, 1, CUBRID_CURSOR_FIRST);
$row = cubrid_fetch($cubrid_req);
print_r($row);

cubrid_commit($cubrid_conn);

cleanup_table($cubrid_conn);

cubrid_free_result($cubrid_req);
cubrid_close_request($cubrid_req);
cubrid_disconnect($cubrid_conn);

echo "</pre>";

?>
